#region usings
using System;
using System.ComponentModel.Composition;
using System.Drawing;
using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.PluginInterfaces.V2.Graph;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "GetSelectedNode",
	Category = "VVVV",
	Help = "Gets ID paths of selected Nodes",
	Tags = "")]
	#endregion PluginInfo
	public class VVVVSetPin : IPluginEvaluate, IPartImportsSatisfiedNotification
	{
		#region fields & pins
		#pragma warning disable 0649
	
		[Output("Node Path")]
		ISpread<string> FValue;

		[Import()]
		IHDEHost FHDEHost;
		
		private INode2[] FSelection; //for storing the selection
  
  		public void OnImportsSatisfied() //called on creation
 		{
   			FHDEHost.NodeSelectionChanged += delegate(object sender, NodeSelectionEventArgs e)
    		{ 
    			FSelection = e.Nodes; 
    		};
  }
		#pragma warning restore
		#endregion fields & pins
		
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
				int NodeCount = FSelection.Length;
				FValue.SliceCount = NodeCount;
				
				for (int i = 0; i < NodeCount; i++)
				{
				 	FValue[i] = FSelection[i].GetNodePath(false);
				}
		}
	}
}
